<?php
/*
  $
*/

  class realex {
    var $code, $title, $description, $enabled;
    var $oid;

// class constructor
    function realex() {
      global $order;

      $this->code = 'realex';
      $this->title = MODULE_PAYMENT_REALEX_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_REALEX_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_REALEX_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_REALEX_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_REALEX_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_REALEX_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      if ( defined('MOBILE_SESSION') || (tep_session_is_registered('mobilesession') && !tep_session_is_registered('MredirectCancelled')) ) {
      	$this->form_action_url = 'https://pay.realexpayments.com/pay';
      } else {
      	$this->form_action_url = 'https://pay.realexpayments.com/pay';
      }
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_REALEX_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_REALEX_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }



//  THIS ADDED (NUMBERS POST CODE EXTRACTION UK ONLY )




function checkPostcode (&$toCheck, &$postcode1, &$postcode2) {

   global $order;

   
  // Permitted letters depend upon their position in the postcode.
  $alpha1 = "[abcdefghijklmnoprstuwyz]";                          // Character 1
  $alpha2 = "[abcdefghklmnopqrstuvwxy]";                          // Character 2
  $alpha3 = "[abcdefghjkpmnrstuvwxy]";                            // Character 3
  $alpha4 = "[abehmnprvwxy]";                                     // Character 4
  $alpha5 = "[abdefghjlnpqrstuwxyz]";                             // Character 5
  $BFPOa5 = "[abdefghjlnpqrst]{1}";                               // BFPO character 5
  $BFPOa6 = "[abdefghjlnpqrstuwzyz]{1}";                          // BFPO character 6
  
  // Expression for BF1 type postcodes 
  $pcexp[0] =  '/^(bf1)([[:space:]]{0,})([0-9]{1}' . $BFPOa5 . $BFPOa6 .')$/';
  
  // Expression for postcodes: AN NAA, ANN NAA, AAN NAA, and AANN NAA with a space  TESTED OK
  $pcexp[1] = '/^('.$alpha1.'{1}'.$alpha2.'{0,1}[0-9]{1,2})([[:space:]]{0,})([0-9]{1}'.$alpha5.'{2})$/';

  // Expression for postcodes: ANA NAA
  $pcexp[2] =  '/^('.$alpha1.'{1}[0-9]{1}'.$alpha3.'{1})([[:space:]]{0,})([0-9]{1}'.$alpha5.'{2})$/';

  // Expression for postcodes: AANA NAA eg. EC2A 4TG
  $pcexp[3] =  '/^('.$alpha1.'{1}'.$alpha2.'{1}[0-9]{1}'.$alpha4.')([[:space:]]{0,})([0-9]{1}'.$alpha5.'{2})$/';
  
  // Exception for the special postcode GIR 0AA
  $pcexp[4] =  '/^(gir)([[:space:]]{0,})(0aa)$/';
  
  // Standard BFPO numbers
  $pcexp[5] = '/^(bfpo)([[:space:]]{0,})([0-9]{1,4})$/';
  
  // c/o BFPO numbers
  $pcexp[6] = '/^(bfpo)([[:space:]]{0,})(c\/o([[:space:]]{0,})[0-9]{1,3})$/';
  
  // Overseas Territories
  $pcexp[7] = '/^([a-z]{4})([[:space:]]{0,})(1zz)$/';
  


  // Load up the string to check, converting into lowercase
  $postcode = strtolower($toCheck);

  // Assume we are not going to find a valid postcode
  $valid = false;
  
  // Check the string against the six types of postcodes
  foreach ($pcexp as $regexp) {
  
    if (preg_match($regexp,$postcode, $matches)) {
    
      // Load new postcode back into the form element 



		$postcode1 = $matches[1];
		$postcode2 = $matches[3];

 
	
      // Take account of the special BFPO c/o format
      $postcode = preg_replace ('/C\/O([[:space:]]{0,})/', 'c/o ', $postcode);
      
     
      
      // Remember that we have found that the code is valid and break from loop
      $valid = true;
      break;
    }
  }
    
  // Return with the reformatted valid postcode in uppercase if the postcode was 
  // valid
  if ($valid){
	  $toCheck = $postcode; 
		return true;
	} 
	else return false;
}






// EOF POSTCODE NUMBER EXTRACTION CODE










    function process_button() {
      global $osC_Session, $order, $currencies;

      if (MODULE_PAYMENT_REALEX_CURRENCY == 'Selected Currency') {
          $my_currency = isset($_SESSION['currency']) ? $_SESSION['currency'] : 'Not defined';
      } else {
        $my_currency = substr(MODULE_PAYMENT_REALEX_CURRENCY, 5);
      }

      if (!in_array($my_currency, array('CHF', 'EUR', 'GBP', 'JPY', 'USD', 'SEK', 'HKD'))) {
        $my_currency = 'GBP'; // INSERT YOUR DEFAULT CURRENCY HERE
      }

      //Replace these with the values you receive from Realex Payments, comes from module settings
      $merchantid = MODULE_PAYMENT_REALEX_ID;
      $secret = MODULE_PAYMENT_REALEX_SECRET;

      if ( defined('MOBILE_SESSION') || (tep_session_is_registered('mobilesession') && !tep_session_is_registered('MredirectCancelled')) ) {
      	$account = 'mobile';
      } else {
      	$account = MODULE_PAYMENT_REALEX_ACCOUNT;
      }

      //The code below is used to create the timestamp format required by Realex Payments
      $timestamp = strftime("%Y%m%d%H%M%S");
      mt_srand((double)microtime()*1000000);

      /* orderid: Timestamp - randvalue */

      $orderid = $timestamp . "-" . mt_rand(1, 999);

      $curr = $my_currency;
      $amount = number_format($order->info['total'] * $currencies->get_value($my_currency), $currencies->get_decimal_places($my_currency), '.', '') * 100;

      // postcode extraction code for AVS here



$postcode=$order->billing['postcode'];  // Load with given post code
$postcode1='';
$postcode2='';
    if (!$this->checkPostcode ($postcode,$postcode1,$postcode2) ) {
      $res1='inva' ;
      $res2='lid' ;  // show 'invalid' as formatted postcode if invalid.
    }
else  {

  preg_match ("/([0-9]*)([a-z])?$/", $postcode1, $matches);
  $res1=$matches[1];
  preg_match ("/^[0-9]/", $postcode2, $matches);
  $res2=$matches[0];


//	$postcode now contains formatted postcode with gap (Not used)
//	$res1 contains first half of postcode ($postcode1) numbers only 
//	$res2 contains second half of postcode ($postcode2) numbers only 

	}

//  extract numbers from address


preg_match_all('!\d+!', $order->billing[street_address], $matches);
$res3 = implode('', $matches[0]);

 $JF_BILLINNG_CO = $order->billing['country']['iso_code_2'];
 if ($JF_BILLINNG_CO == 'YA') $JF_BILLINNG_CO = 'GB';  // THESE ARE TO CREATE DIFFERENT SHIPPING ZONES WITHIN UK, YOU MAY WANT TO DELETE IF YOU DONT CREATE THEM IN SHIPPING ZONES
 if ($JF_BILLINNG_CO == 'YB') $JF_BILLINNG_CO = 'GB';  // THESE ARE TO CREATE DIFFERENT SHIPPING ZONES WITHIN UK, YOU MAY WANT TO DELETE IF YOU DONT CREATE THEM IN SHIPPING ZONES
 if ($JF_BILLINNG_CO == 'YC') $JF_BILLINNG_CO = 'GB';  // THESE ARE TO CREATE DIFFERENT SHIPPING ZONES WITHIN UK, YOU MAY WANT TO DELETE IF YOU DONT CREATE THEM IN SHIPPING ZONES
 if ($JF_BILLINNG_CO == 'YD') $JF_BILLINNG_CO = 'GB';  // THESE ARE TO CREATE DIFFERENT SHIPPING ZONES WITHIN UK, YOU MAY WANT TO DELETE IF YOU DONT CREATE THEM IN SHIPPING ZONES
 if ($JF_BILLINNG_CO == 'YF') $JF_BILLINNG_CO = 'GB';  // THESE ARE TO CREATE DIFFERENT SHIPPING ZONES WITHIN UK, YOU MAY WANT TO DELETE IF YOU DONT CREATE THEM IN SHIPPING ZONES
 if ($JF_BILLINNG_CO == 'YG') $JF_BILLINNG_CO = 'GB';  // THESE ARE TO CREATE DIFFERENT SHIPPING ZONES WITHIN UK, YOU MAY WANT TO DELETE IF YOU DONT CREATE THEM IN SHIPPING ZONES
 if ($JF_BILLINNG_CO == 'YH') $JF_BILLINNG_CO = 'GB';  // THESE ARE TO CREATE DIFFERENT SHIPPING ZONES WITHIN UK, YOU MAY WANT TO DELETE IF YOU DONT CREATE THEM IN SHIPPING ZONES
 if ($JF_BILLINNG_CO == 'YI') $JF_BILLINNG_CO = 'GB';  // THESE ARE TO CREATE DIFFERENT SHIPPING ZONES WITHIN UK, YOU MAY WANT TO DELETE IF YOU DONT CREATE THEM IN SHIPPING ZONES
 if ($JF_BILLINNG_CO == 'XX') $JF_BILLINNG_CO = 'GB';  // THESE ARE TO CREATE DIFFERENT SHIPPING ZONES WITHIN UK, YOU MAY WANT TO DELETE IF YOU DONT CREATE THEM IN SHIPPING ZONES



      /*md5 crypt*/
      $tmp = "$timestamp.$merchantid.$orderid.$amount.$curr";
      $md5hash = md5($tmp);
      $tmp = "$md5hash.$secret";
      $md5hash = md5($tmp);
	    try {
		    $additionalFields = $this->gp_get_additional_hpp_fields_as_markup();
	    } catch (Exception $exception) {
		    $additionalFields = '';
	    }		  
      $process_button_string = tep_draw_hidden_field('MERCHANT_ID', MODULE_PAYMENT_REALEX_ID) .
                               tep_draw_hidden_field('osCsid', session_id()) .				tep_draw_hidden_field('ACCOUNT',$account) .
                               tep_draw_hidden_field('ORDER_ID', $orderid) .
                               tep_draw_hidden_field('AMOUNT', $amount) .
                               tep_draw_hidden_field('CURRENCY', $curr) .
                               tep_draw_hidden_field('TIMESTAMP', $timestamp) .
                               tep_draw_hidden_field('AUTO_SETTLE_FLAG', 1) .
                               tep_draw_hidden_field('RETURN_TSS', 1) .
                               tep_draw_hidden_field('BILLING_CODE', $res1.$res2.'|'.$res3) .
                          //   tep_draw_hidden_field('BILLING_CO', $order->billing['country']['iso_code_2']) .  
						 	   tep_draw_hidden_field('BILLING_CO', $JF_BILLINNG_CO) .  // TO FACILITATE UK ZONES, IF NOT USED COMMENT OUT AND USE LINE ABOVE INSTEAD
                               tep_draw_hidden_field('MD5HASH', $md5hash).
                               tep_draw_hidden_field('COMMENT', urldecode($order->billing['firstname']) . ' ' . urldecode($order->billing['lastname']) . (strlen($order->billing['company'])>0?' ' . urldecode($order->billing['company']):'') ) .
                               tep_draw_hidden_field('PROD_ID', STORE_NAME). $additionalFields;

      return $process_button_string;
    }

    function before_process() {
      global $_POST;

      $error = false;
      
      $merchantid = MODULE_PAYMENT_REALEX_ID;
      $secret = MODULE_PAYMENT_REALEX_SECRET;

      $account = $_POST['ACCOUNT'];
      $timestamp = $_POST['TIMESTAMP'];
      $result = $_POST['RESULT'];
      $orderid = $_POST['ORDER_ID'];
      $message = $_POST['MESSAGE'];
      $authcode = $_POST['AUTHCODE'];
      $pasref = $_POST['PASREF'];
      $md5hash_post = $_POST['MD5HASH'];

      $tmp = "$timestamp.$merchantid.$orderid.$result.$message.$pasref.$authcode";
      $md5hash_new = md5($tmp);
      $tmp = "$md5hash_new.$secret";
      $md5hash_new = md5($tmp);

      //Check to see if hashes match or not
      if ($md5hash_new != $md5hash_post) {
                                $payment_error_return = 'payment_error=' . $this->code . '&error=' . TEXT_REALEX_HASH_ERROR;
                                tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }

      if ($result !='00') {
                                $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($message);
                                tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }
      

      return false;
    }

    function after_process() {
      return false;
    }


    function get_error() {
      if (PHP_VERSION < 4.1) {
        global $_GET;
      }

      $error = array('title' => REALEX_ERROR_TITLE,
                     'error' => ((isset($_GET['error'])) ? stripslashes(urldecode($_GET['error'])) : IPAYMENT_ERROR_MESSAGE));

      return $error;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_REALEX_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Realex Module', 'MODULE_PAYMENT_REALEX_STATUS', 'True', 'Do you want to accept Realex payments?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Account', 'MODULE_PAYMENT_REALEX_ACCOUNT', 'Internet', 'The Account (or sub-Account) is provided by realex. Leave it set to \'Internet\' unless instructed by Realex.', '6', '5', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_REALEX_ID', 'MerchantID', 'The merchant ID provided by realex', '6', '5', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Shared Secret', 'MODULE_PAYMENT_REALEX_SECRET', 'Secret', 'The Shared Secret provided by realex', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Currency', 'MODULE_PAYMENT_REALEX_CURRENCY', 'Selected Currency', 'The currency to use for credit card transactions', '6', '6', 'tep_cfg_select_option(array(\'Selected Currency\',\'Only USD\',\'Only CHF\',\'Only EUR\',\'Only GBP\',\'Only JPY\', \'Only HKD\', \'Only SEK\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_REALEX_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_REALEX_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_REALEX_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
 	return array('MODULE_PAYMENT_REALEX_STATUS', 'MODULE_PAYMENT_REALEX_ID', 'MODULE_PAYMENT_REALEX_ACCOUNT', 'MODULE_PAYMENT_REALEX_SECRET',  'MODULE_PAYMENT_REALEX_CURRENCY', 'MODULE_PAYMENT_REALEX_ZONE', 'MODULE_PAYMENT_REALEX_ORDER_STATUS_ID', 'MODULE_PAYMENT_REALEX_SORT_ORDER');
    }
	
	/**
     *
     * @return array
     */
    function gp_get_additional_hpp_fields()
    {
	    /** @var order $order */
      global $order;
      $fields = [];
      
      /** @noinspection PhpUndefinedClassInspection */
	    /** @noinspection PhpUndefinedFieldInspection */
	    $billingAddress = $order->billing;
      
      $additionalHppData[] = array(
        "HPP_VERSION"           => 2,
        "MERCHANT_RESPONSE_URL" => tep_href_link('before_process.php', '', 'SSL', true, false),
        "HPP_CUSTOMER_EMAIL"    => isset($order->customer['email_address']) ? $order->customer['email_address'] : '',
      );
      
      $phoneCodes         = $this->gp_get_country_phone_codes();
      $billingPhoneNumber = @isset($order->customer['telephone']) ? $order->customer['telephone'] : false;
      $customerCountryIsoCode = @isset($order->customer['country']['iso_code_2']) ? $order->customer['country']['iso_code_2'] : false;
      if ($billingPhoneNumber && $customerCountryIsoCode && isset($phoneCodes[$customerCountryIsoCode])) {
        $phoneCode = $phoneCodes[$customerCountryIsoCode];
        
        $formattedPhoneNumber = preg_replace("/^0+|[^\d]/", '', $billingPhoneNumber);
        if (substr($formattedPhoneNumber, 0, strlen($phoneCode)) === $phoneCode) {
          $formattedPhoneNumber = substr($formattedPhoneNumber, strlen($phoneCode));
        }
        
        if (is_string($formattedPhoneNumber)) {
          $additionalHppData["HPP_CUSTOMER_PHONENUMBER_MOBILE"] = $phoneCode . '|' . $formattedPhoneNumber;
        }
      }
	
	    $hppBillingState = $billingAddress && in_array(@$billingAddress['country']['iso_code_2'], array('US', 'CA'))
		    ? tep_get_zone_code($billingAddress['country_id'], $billingAddress['zone_id'], $billingAddress['state'])
		    : '';
	
	    $hppBillingFields    = array(
       // "HPP_BILLING_STREET1"    => $billingAddress && isset($billingAddress['street_address']) ? $billingAddress['street_address'] : '',
		"HPP_BILLING_STREET1"    => $billingAddress && isset($billingAddress['street_address']) ? str_replace(array( '(', ')' ), '', $billingAddress['street_address']) : '', // REMOVE BRACKETS CODE
        "HPP_BILLING_STREET2"    => '',
        "HPP_BILLING_STREET3"    => '',
        "HPP_BILLING_CITY"       => $billingAddress && isset($billingAddress['city']) ? $billingAddress['city'] : '',
        "HPP_BILLING_STATE"      => $hppBillingState,
        "HPP_BILLING_POSTALCODE" => $billingAddress && isset($billingAddress['postcode']) ? $billingAddress['postcode'] : '',
        "HPP_BILLING_COUNTRY"    => $billingAddress && isset($billingAddress['country']['iso_code_2']) ? $this->gp_get_country_numeric_code($billingAddress['country']['iso_code_2']) : '',
      );
      $additionalHppData[] = $hppBillingFields;
      
      
      $shippingAddress   = isset($order->delivery) ? $order->delivery : false;
	
	    $hppShippingState = $shippingAddress && in_array(@$shippingAddress['country']['iso_code_2'], array('US', 'CA'))
		    ? tep_get_zone_code($shippingAddress['country_id'], $shippingAddress['zone_id'], $shippingAddress['state'])
		    : '';
      $hppShippingFields = array(
       // "HPP_SHIPPING_STREET1"    => $shippingAddress && isset($shippingAddress['street_address']) ? $shippingAddress['street_address'] : '',
		"HPP_SHIPPING_STREET1"    => $shippingAddress && isset($shippingAddress['street_address']) ? str_replace(array( '(', ')' ), '', $shippingAddress['street_address']) : '', // REMOVE BRACKETS CODE
        "HPP_SHIPPING_STREET2"    => '',
        "HPP_SHIPPING_STREET3"    => '',
        "HPP_SHIPPING_CITY"       => $shippingAddress && isset($shippingAddress['city']) ? $shippingAddress['city'] : '',
        "HPP_SHIPPING_STATE"      => $hppShippingState,
        "HPP_SHIPPING_POSTALCODE" => $shippingAddress && isset($shippingAddress['postcode']) ? $shippingAddress['postcode'] : '',
        "HPP_SHIPPING_COUNTRY"    => $shippingAddress && isset($shippingAddress['country']['iso_code_2']) ? $this->gp_get_country_numeric_code($shippingAddress['country']['iso_code_2']) : ''
      );
      
      
      // order and type matter
      if (array_values($hppBillingFields) === array_values($hppShippingFields)) {
        $additionalHppData["HPP_ADDRESS_MATCH_INDICATOR"] = "TRUE";
        $additionalHppData[]                              = $hppShippingFields;
      } else {
        $additionalHppData["HPP_ADDRESS_MATCH_INDICATOR"] = "FALSE";
        $additionalHppData[]                              = $hppShippingFields;
      }
      
      $additionalHppData["COMMENT1"] = 'oscommerce';
      
      foreach ($additionalHppData as $additionalHppProp => $additionalHppValue) {
        if (is_array($additionalHppValue)) {
          foreach ($additionalHppValue as $additionalHppPropChild => $additionalHppValueChild) {
            $fields[$additionalHppPropChild] = $additionalHppValueChild;
          }
        } else {
          $fields[$additionalHppProp] = $additionalHppValue;
        }
      }
      
      return $fields;
    }
	
	
	    /**
     * @return string
     */
    function gp_get_additional_hpp_fields_as_markup()
    {
      $additionalHppFields = $this->gp_get_additional_hpp_fields();
      $additionalHppFieldsMarkup = '';
      foreach ($additionalHppFields as $hppKey => $hppValue) {
        $additionalHppFieldsMarkup .= tep_draw_hidden_field($hppKey, $hppValue);
      }
      
      return $additionalHppFieldsMarkup;
    }
    
	  /**
     * @return array
     */
    private function gp_get_country_numeric_codes()
    {
      return array(
        'AF' => '004',
        'AX' => '248',
        'AL' => '008',
        'DZ' => '012',
        'AS' => '016',
        'AD' => '020',
        'AO' => '024',
        'AI' => '660',
        'AQ' => '010',
        'AG' => '028',
        'AR' => '032',
        'AM' => '051',
        'AW' => '533',
        'AU' => '036',
        'AT' => '040',
        'AZ' => '031',
        'BS' => '044',
        'BH' => '048',
        'BD' => '050',
        'BB' => '052',
        'BY' => '112',
        'BE' => '056',
        'BZ' => '084',
        'BJ' => '204',
        'BM' => '060',
        'BT' => '064',
        'BO' => '068',
        'BQ' => '535',
        'BA' => '070',
        'BW' => '072',
        'BV' => '074',
        'BR' => '076',
        'IO' => '086',
        'BN' => '096',
        'BG' => '100',
        'BF' => '854',
        'BI' => '108',
        'CV' => '132',
        'KH' => '116',
        'CM' => '120',
        'CA' => '124',
        'KY' => '136',
        'CF' => '140',
        'TD' => '148',
        'CL' => '152',
        'CN' => '156',
        'CX' => '162',
        'CC' => '166',
        'CO' => '170',
        'KM' => '174',
        'CG' => '178',
        'CD' => '180',
        'CK' => '184',
        'CR' => '188',
        'CI' => '384',
        'HR' => '191',
        'CU' => '192',
        'CW' => '531',
        'CY' => '196',
        'CZ' => '203',
        'DK' => '208',
        'DJ' => '262',
        'DM' => '212',
        'DO' => '214',
        'EC' => '218',
        'EG' => '818',
        'SV' => '222',
        'GQ' => '226',
        'ER' => '232',
        'EE' => '233',
        'ET' => '231',
        'SZ' => '748',
        'FK' => '238',
        'FO' => '234',
        'FJ' => '242',
        'FI' => '246',
        'FR' => '250',
        'GF' => '254',
        'PF' => '258',
        'TF' => '260',
        'GA' => '266',
        'GM' => '270',
        'GE' => '268',
        'DE' => '276',
        'GH' => '288',
        'GI' => '292',
        'GR' => '300',
        'GL' => '304',
        'GD' => '308',
        'GP' => '312',
        'GU' => '316',
        'GT' => '320',
        'GG' => '831',
        'GN' => '324',
        'GW' => '624',
        'GY' => '328',
        'HT' => '332',
        'HM' => '334',
        'VA' => '336',
        'HN' => '340',
        'HK' => '344',
        'HU' => '348',
        'IS' => '352',
        'IN' => '356',
        'ID' => '360',
        'IR' => '364',
        'IQ' => '368',
        'IE' => '372',
        'IM' => '833',
        'IL' => '376',
        'IT' => '380',
        'JM' => '388',
        'JP' => '392',
        'JE' => '832',
        'JO' => '400',
        'KZ' => '398',
        'KE' => '404',
        'KI' => '296',
        'KP' => '408',
        'KR' => '410',
        'KW' => '414',
        'KG' => '417',
        'LA' => '418',
        'LV' => '428',
        'LB' => '422',
        'LS' => '426',
        'LR' => '430',
        'LY' => '434',
        'LI' => '438',
        'LT' => '440',
        'LU' => '442',
        'MO' => '446',
        'MK' => '807',
        'MG' => '450',
        'MW' => '454',
        'MY' => '458',
        'MV' => '462',
        'ML' => '466',
        'MT' => '470',
        'MH' => '584',
        'MQ' => '474',
        'MR' => '478',
        'MU' => '480',
        'YT' => '175',
        'MX' => '484',
        'FM' => '583',
        'MD' => '498',
        'MC' => '492',
        'MN' => '496',
        'ME' => '499',
        'MS' => '500',
        'MA' => '504',
        'MZ' => '508',
        'MM' => '104',
        'NA' => '516',
        'NR' => '520',
        'NP' => '524',
        'NL' => '528',
        'NC' => '540',
        'NZ' => '554',
        'NI' => '558',
        'NE' => '562',
        'NG' => '566',
        'NU' => '570',
        'NF' => '574',
        'MP' => '580',
        'NO' => '578',
        'OM' => '512',
        'PK' => '586',
        'PW' => '585',
        'PS' => '275',
        'PA' => '591',
        'PG' => '598',
        'PY' => '600',
        'PE' => '604',
        'PH' => '608',
        'PN' => '612',
        'PL' => '616',
        'PT' => '620',
        'PR' => '630',
        'QA' => '634',
        'RE' => '638',
        'RO' => '642',
        'RU' => '643',
        'RW' => '646',
        'BL' => '652',
        'SH' => '654',
        'KN' => '659',
        'LC' => '662',
        'MF' => '663',
        'PM' => '666',
        'VC' => '670',
        'WS' => '882',
        'SM' => '674',
        'ST' => '678',
        'SA' => '682',
        'SN' => '686',
        'RS' => '688',
        'SC' => '690',
        'SL' => '694',
        'SG' => '702',
        'SX' => '534',
        'SK' => '703',
        'SI' => '705',
        'SB' => '090',
        'SO' => '706',
        'ZA' => '710',
        'GS' => '239',
        'SS' => '728',
        'ES' => '724',
        'LK' => '144',
        'SD' => '729',
        'SR' => '740',
        'SJ' => '744',
        'SE' => '752',
        'CH' => '756',
        'SY' => '760',
        'TW' => '158',
        'TJ' => '762',
        'TZ' => '834',
        'TH' => '764',
        'TL' => '626',
        'TG' => '768',
        'TK' => '772',
        'TO' => '776',
        'TT' => '780',
        'TN' => '788',
        'TR' => '792',
        'TM' => '795',
        'TC' => '796',
        'TV' => '798',
        'UG' => '800',
        'UA' => '804',
        'AE' => '784',
        'GB' => '826',
        'US' => '840',
        'UM' => '581',
        'UY' => '858',
        'UZ' => '860',
        'VU' => '548',
        'VE' => '862',
        'VN' => '704',
        'VG' => '092',
        'VI' => '850',
        'WF' => '876',
        'EH' => '732',
        'YE' => '887',
        'ZM' => '894',
        'ZW' => '716',
		'YA' => '826', // extra code for GB zones
		'YB' => '826', // extra code for GB zones
		'YC' => '826', // extra code for GB zones
		'YD' => '826', // extra code for GB zones
		'YF' => '826', // extra code for GB zones
		'YG' => '826', // extra code for GB zones
		'YH' => '826', // extra code for GB zones
		'YI' => '826', // extra code for GB zones
		'XX' => '826', // extra code for GB zones
	      );
    }
    
    private function gp_get_country_phone_codes() {
      return array(
        'AD' => '376',
        'AE' => '971',
        'AF' => '93',
        'AG' => '1268',
        'AI' => '1264',
        'AL' => '355',
        'AM' => '374',
        'AN' => '599',
        'AO' => '244',
        'AQ' => '672',
        'AR' => '54',
        'AS' => '1684',
        'AT' => '43',
        'AU' => '61',
        'AW' => '297',
        'AZ' => '994',
        'BA' => '387',
        'BB' => '1246',
        'BD' => '880',
        'BE' => '32',
        'BF' => '226',
        'BG' => '359',
        'BH' => '973',
        'BI' => '257',
        'BJ' => '229',
        'BL' => '590',
        'BM' => '1441',
        'BN' => '673',
        'BO' => '591',
        'BR' => '55',
        'BS' => '1242',
        'BT' => '975',
        'BW' => '267',
        'BY' => '375',
        'BZ' => '501',
        'CA' => '1',
        'CC' => '61',
        'CD' => '243',
        'CF' => '236',
        'CG' => '242',
        'CH' => '41',
        'CI' => '225',
        'CK' => '682',
        'CL' => '56',
        'CM' => '237',
        'CN' => '86',
        'CO' => '57',
        'CR' => '506',
        'CU' => '53',
        'CV' => '238',
        'CX' => '61',
        'CY' => '357',
        'CZ' => '420',
        'DE' => '49',
        'DJ' => '253',
        'DK' => '45',
        'DM' => '1767',
        'DO' => '1809',
        'DZ' => '213',
        'EC' => '593',
        'EE' => '372',
        'EG' => '20',
        'ER' => '291',
        'ES' => '34',
        'ET' => '251',
        'FI' => '358',
        'FJ' => '679',
        'FK' => '500',
        'FM' => '691',
        'FO' => '298',
        'FR' => '33',
        'GA' => '241',
        'GB' => '44',
        'GD' => '1473',
        'GE' => '995',
        'GH' => '233',
        'GI' => '350',
        'GL' => '299',
        'GM' => '220',
        'GN' => '224',
        'GQ' => '240',
        'GR' => '30',
        'GT' => '502',
        'GU' => '1671',
        'GW' => '245',
        'GY' => '592',
        'HK' => '852',
        'HN' => '504',
        'HR' => '385',
        'HT' => '509',
        'HU' => '36',
        'ID' => '62',
        'IE' => '353',
        'IL' => '972',
        'IM' => '44',
        'IN' => '91',
        'IQ' => '964',
        'IR' => '98',
        'IS' => '354',
        'IT' => '39',
        'JM' => '1876',
        'JO' => '962',
        'JP' => '81',
        'KE' => '254',
        'KG' => '996',
        'KH' => '855',
        'KI' => '686',
        'KM' => '269',
        'KN' => '1869',
        'KP' => '850',
        'KR' => '82',
        'KW' => '965',
        'KY' => '1345',
        'KZ' => '7',
        'LA' => '856',
        'LB' => '961',
        'LC' => '1758',
        'LI' => '423',
        'LK' => '94',
        'LR' => '231',
        'LS' => '266',
        'LT' => '370',
        'LU' => '352',
        'LV' => '371',
        'LY' => '218',
        'MA' => '212',
        'MC' => '377',
        'MD' => '373',
        'ME' => '382',
        'MF' => '1599',
        'MG' => '261',
        'MH' => '692',
        'MK' => '389',
        'ML' => '223',
        'MM' => '95',
        'MN' => '976',
        'MO' => '853',
        'MP' => '1670',
        'MR' => '222',
        'MS' => '1664',
        'MT' => '356',
        'MU' => '230',
        'MV' => '960',
        'MW' => '265',
        'MX' => '52',
        'MY' => '60',
        'MZ' => '258',
        'NA' => '264',
        'NC' => '687',
        'NE' => '227',
        'NG' => '234',
        'NI' => '505',
        'NL' => '31',
        'NO' => '47',
        'NP' => '977',
        'NR' => '674',
        'NU' => '683',
        'NZ' => '64',
        'OM' => '968',
        'PA' => '507',
        'PE' => '51',
        'PF' => '689',
        'PG' => '675',
        'PH' => '63',
        'PK' => '92',
        'PL' => '48',
        'PM' => '508',
        'PN' => '870',
        'PR' => '1',
        'PT' => '351',
        'PW' => '680',
        'PY' => '595',
        'QA' => '974',
        'RO' => '40',
        'RS' => '381',
        'RU' => '7',
        'RW' => '250',
        'SA' => '966',
        'SB' => '677',
        'SC' => '248',
        'SD' => '249',
        'SE' => '46',
        'SG' => '65',
        'SH' => '290',
        'SI' => '386',
        'SK' => '421',
        'SL' => '232',
        'SM' => '378',
        'SN' => '221',
        'SO' => '252',
        'SR' => '597',
        'ST' => '239',
        'SV' => '503',
        'SY' => '963',
        'SZ' => '268',
        'TC' => '1649',
        'TD' => '235',
        'TG' => '228',
        'TH' => '66',
        'TJ' => '992',
        'TK' => '690',
        'TL' => '670',
        'TM' => '993',
        'TN' => '216',
        'TO' => '676',
        'TR' => '90',
        'TT' => '1868',
        'TV' => '688',
        'TW' => '886',
        'TZ' => '255',
        'UA' => '380',
        'UG' => '256',
        'US' => '1',
        'UY' => '598',
        'UZ' => '998',
        'VA' => '39',
        'VC' => '1784',
        'VE' => '58',
        'VG' => '1284',
        'VI' => '1340',
        'VN' => '84',
        'VU' => '678',
        'WF' => '681',
        'WS' => '685',
        'XK' => '381',
        'YE' => '967',
        'YT' => '262',
        'ZA' => '27',
        'ZM' => '260',
        'ZW' => '263',
		'YA' => '44', // extra code for GB zones
		'YB' => '44', // extra code for GB zones
		'YC' => '44', // extra code for GB zones
		'YD' => '44', // extra code for GB zones
		'YF' => '44', // extra code for GB zones
		'YG' => '44', // extra code for GB zones
		'YH' => '44', // extra code for GB zones
		'YI' => '44', // extra code for GB zones
		'XX' => '44', // extra code for GB zones
      );
    }
	
	    /**
     * @param $alpha2
     *
     * @return mixed|string
     */
    private function gp_get_country_numeric_code($alpha2)
    {
      $countries = $this->gp_get_country_numeric_codes();
      
      return isset($countries[$alpha2]) ? $countries[$alpha2] : '';
    }
  }
?>
